package com.uca.dao;

import com.uca.entity.EleveEntity;

import java.sql.*;
import java.util.ArrayList;

public class EleveDAO extends _Generic<EleveEntity> {

    public ArrayList<EleveEntity> getAllEleves() {
        ArrayList<EleveEntity> entities = new ArrayList<>();
        try {
            PreparedStatement preparedStatement = this.connect
                    .prepareStatement("SELECT * FROM eleves ORDER BY id ASC;");
            ResultSet resultSet = preparedStatement.executeQuery();
            while (resultSet.next()) {
                EleveEntity entity = new EleveEntity();
                entity.setId(resultSet.getInt("id"));
                entity.setFirstName(resultSet.getString("firstname"));
                entity.setLastName (resultSet.getString("lastname"));
                entity.setNaissance(resultSet.getString("dateNaissance"));
                entity.setNomClasse(resultSet.getString("nomClasse"));

                entities.add(entity);
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }

        return entities;
    }

    @Override
    public EleveEntity create(EleveEntity obj) {
        try {
            PreparedStatement stmt = this.connect.prepareStatement("insert into eleves (id, firstName, lastName, nomClasse, dateNaissance) values (?, ?, ?, ?, ?);");
            int idx = 1;
            stmt.setInt   (idx++, obj.getId());
            stmt.setString(idx++, obj.getFirstName());
            stmt.setString(idx++, obj.getLastName());
            stmt.setString(idx++, obj.getNomClasse());
            stmt.setString(idx++, obj.getNaissance());
            ResultSet rs = stmt.executeQuery() ;
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return obj;
    }

    @Override
    public void delete(EleveEntity obj) {
        delete(obj.getId());
    }

    public void delete(int id) {
        try {
            PreparedStatement stmt = this.connect.prepareStatement("DELETE FROM eleves WHERE id = ?;");
            stmt.setInt   (1, id);
            ResultSet rs = stmt.executeQuery() ;
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
}
